# SPDX-FileCopyrightText: 2020 Mintlab B.V.
#
# SPDX-License-Identifier: EUPL-1.2

# AUTOGENERATED FILE - No need to edit
# GENERATED AT: 2021-06-07T10:16:05"
# Re-create by running 'generate-routes' command
# Run 'generate-routes --help' for more options

import webtest
from unittest import TestCase, mock
from zsnl_admin_http import main, views


class TestRoutes_apidocs(TestCase):
    def setUp(self):
        self.patched_apidocs = mock.patch(
            "zsnl_admin_http.views.apidocs", spec=views.apidocs
        )
        self.apidocs = self.patched_apidocs.start()

        settings = {
            "minty_service.infrastructure.config_file": "tests/data/config.conf"
        }
        app = main({}, **settings)
        self.mock_app = webtest.TestApp(app)

    def tearDown(self):
        self.patched_apidocs.stop()

    def test_routes_apidocs(self):
        self.apidocs.apidocs_fileserver.return_value = 200
        self.mock_app.get(
            "/api/v2/admin/catalog/openapi/{filename}", status=200
        )


class TestRoutes_views(TestCase):
    def setUp(self):
        self.patched_views = mock.patch(
            "zsnl_admin_http.views.views", spec=views.views
        )
        self.views = self.patched_views.start()

        settings = {
            "minty_service.infrastructure.config_file": "tests/data/config.conf"
        }
        app = main({}, **settings)
        self.mock_app = webtest.TestApp(app)

    def tearDown(self):
        self.patched_views.stop()

    def test_routes_views(self):
        self.views.get_folder_contents.return_value = 200
        self.mock_app.get(
            "/api/v2/admin/catalog/get_folder_contents", status=200
        )
        self.views.get_entry_detail.return_value = 200
        self.mock_app.get("/api/v2/admin/catalog/get_entry_detail", status=200)
        self.views.move_folder_entries.return_value = 200
        self.mock_app.post(
            "/api/v2/admin/catalog/move_folder_entries", status=200
        )
        self.views.change_case_type_online_status.return_value = 200
        self.mock_app.post(
            "/api/v2/admin/catalog/change_case_type_online_status", status=200
        )
        self.views.get_attribute_detail.return_value = 200
        self.mock_app.get(
            "/api/v2/admin/catalog/get_attribute_detail", status=200
        )
        self.views.edit_attribute.return_value = 200
        self.mock_app.post("/api/v2/admin/catalog/edit_attribute", status=200)
        self.views.create_attribute.return_value = 200
        self.mock_app.post(
            "/api/v2/admin/catalog/create_attribute", status=200
        )
        self.views.generate_magic_string.return_value = 200
        self.mock_app.get(
            "/api/v2/admin/catalog/generate_magic_string", status=200
        )
        self.views.create_folder.return_value = 200
        self.mock_app.post("/api/v2/admin/catalog/create_folder", status=200)
        self.views.rename_folder.return_value = 200
        self.mock_app.post("/api/v2/admin/catalog/rename_folder", status=200)
        self.views.search_catalog.return_value = 200
        self.mock_app.get("/api/v2/admin/catalog/search", status=200)
        self.views.get_case_type_history.return_value = 200
        self.mock_app.get(
            "/api/v2/admin/catalog/get_case_type_history", status=200
        )
        self.views.update_case_type_version.return_value = 200
        self.mock_app.post(
            "/api/v2/admin/catalog/activate_case_type_version", status=200
        )


class TestRoutes_attribute_views(TestCase):
    def setUp(self):
        self.patched_attribute_views = mock.patch(
            "zsnl_admin_http.views.attribute_views", spec=views.attribute_views
        )
        self.attribute_views = self.patched_attribute_views.start()

        settings = {
            "minty_service.infrastructure.config_file": "tests/data/config.conf"
        }
        app = main({}, **settings)
        self.mock_app = webtest.TestApp(app)

    def tearDown(self):
        self.patched_attribute_views.stop()

    def test_routes_attribute_views(self):
        self.attribute_views.search_attribute_by_name.return_value = 200
        self.mock_app.get("/api/v2/admin/catalog/attribute_search", status=200)
        self.attribute_views.delete_attribute.return_value = 200
        self.mock_app.post(
            "/api/v2/admin/catalog/delete_attribute", status=200
        )


class TestRoutes_email_template(TestCase):
    def setUp(self):
        self.patched_email_template = mock.patch(
            "zsnl_admin_http.views.email_template", spec=views.email_template
        )
        self.email_template = self.patched_email_template.start()

        settings = {
            "minty_service.infrastructure.config_file": "tests/data/config.conf"
        }
        app = main({}, **settings)
        self.mock_app = webtest.TestApp(app)

    def tearDown(self):
        self.patched_email_template.stop()

    def test_routes_email_template(self):
        self.email_template.get_email_template_detail.return_value = 200
        self.mock_app.get(
            "/api/v2/admin/catalog/get_email_template_detail", status=200
        )
        self.email_template.create_an_email_template.return_value = 200
        self.mock_app.post(
            "/api/v2/admin/catalog/create_email_template", status=200
        )
        self.email_template.edit_an_email_template.return_value = 200
        self.mock_app.post(
            "/api/v2/admin/catalog/edit_email_template", status=200
        )
        self.email_template.delete_email_template.return_value = 200
        self.mock_app.post(
            "/api/v2/admin/catalog/delete_email_template", status=200
        )


class TestRoutes_integrations_views(TestCase):
    def setUp(self):
        self.patched_integrations_views = mock.patch(
            "zsnl_admin_http.views.integrations_views",
            spec=views.integrations_views,
        )
        self.integrations_views = self.patched_integrations_views.start()

        settings = {
            "minty_service.infrastructure.config_file": "tests/data/config.conf"
        }
        app = main({}, **settings)
        self.mock_app = webtest.TestApp(app)

    def tearDown(self):
        self.patched_integrations_views.stop()

    def test_routes_integrations_views(self):
        self.integrations_views.get_active_document_integrations.return_value = (
            200
        )
        self.mock_app.get(
            "/api/v2/admin/integrations/get_active_document_integrations",
            status=200,
        )
        self.integrations_views.get_active_appointment_integrations.return_value = (
            200
        )
        self.mock_app.get(
            "/api/v2/admin/integrations/get_active_appointment_integrations",
            status=200,
        )
        self.integrations_views.get_active_appointment_v2_integrations.return_value = (
            200
        )
        self.mock_app.get(
            "/api/v2/admin/integrations/get_active_appointment_v2_integrations",
            status=200,
        )


class TestRoutes_document_template_views(TestCase):
    def setUp(self):
        self.patched_document_template_views = mock.patch(
            "zsnl_admin_http.views.document_template_views",
            spec=views.document_template_views,
        )
        self.document_template_views = (
            self.patched_document_template_views.start()
        )

        settings = {
            "minty_service.infrastructure.config_file": "tests/data/config.conf"
        }
        app = main({}, **settings)
        self.mock_app = webtest.TestApp(app)

    def tearDown(self):
        self.patched_document_template_views.stop()

    def test_routes_document_template_views(self):
        self.document_template_views.create_document_template.return_value = (
            200
        )
        self.mock_app.post(
            "/api/v2/admin/catalog/create_document_template", status=200
        )
        self.document_template_views.get_document_template_detail.return_value = (
            200
        )
        self.mock_app.get(
            "/api/v2/admin/catalog/get_document_template_detail", status=200
        )
        self.document_template_views.edit_document_template.return_value = 200
        self.mock_app.post(
            "/api/v2/admin/catalog/edit_document_template", status=200
        )
        self.document_template_views.delete_document_template.return_value = (
            200
        )
        self.mock_app.post(
            "/api/v2/admin/catalog/delete_document_template", status=200
        )


class TestRoutes_folder_views(TestCase):
    def setUp(self):
        self.patched_folder_views = mock.patch(
            "zsnl_admin_http.views.folder_views", spec=views.folder_views
        )
        self.folder_views = self.patched_folder_views.start()

        settings = {
            "minty_service.infrastructure.config_file": "tests/data/config.conf"
        }
        app = main({}, **settings)
        self.mock_app = webtest.TestApp(app)

    def tearDown(self):
        self.patched_folder_views.stop()

    def test_routes_folder_views(self):
        self.folder_views.delete_folder.return_value = 200
        self.mock_app.post("/api/v2/admin/catalog/delete_folder", status=200)


class TestRoutes_case_type_views(TestCase):
    def setUp(self):
        self.patched_case_type_views = mock.patch(
            "zsnl_admin_http.views.case_type_views", spec=views.case_type_views
        )
        self.case_type_views = self.patched_case_type_views.start()

        settings = {
            "minty_service.infrastructure.config_file": "tests/data/config.conf"
        }
        app = main({}, **settings)
        self.mock_app = webtest.TestApp(app)

    def tearDown(self):
        self.patched_case_type_views.stop()

    def test_routes_case_type_views(self):
        self.case_type_views.delete_case_type.return_value = 200
        self.mock_app.post(
            "/api/v2/admin/catalog/delete_case_type", status=200
        )


class TestRoutes_object_type_views(TestCase):
    def setUp(self):
        self.patched_object_type_views = mock.patch(
            "zsnl_admin_http.views.object_type_views",
            spec=views.object_type_views,
        )
        self.object_type_views = self.patched_object_type_views.start()

        settings = {
            "minty_service.infrastructure.config_file": "tests/data/config.conf"
        }
        app = main({}, **settings)
        self.mock_app = webtest.TestApp(app)

    def tearDown(self):
        self.patched_object_type_views.stop()

    def test_routes_object_type_views(self):
        self.object_type_views.delete_object_type.return_value = 200
        self.mock_app.post(
            "/api/v2/admin/catalog/delete_object_type", status=200
        )
